<?php

class VibeForms_Touchpoints {


	public static $instance;
    
    public static function init(){
        if ( is_null( self::$instance ) )
            self::$instance = new VibeForms_Touchpoints;
        return self::$instance;
    }

	private function __construct(){
		$this->post_author=[];
		$this->post_title=[];
		add_filter('vibebp_touch_points',array($this,'add_vibe_forms_touch_points'));
    	add_filter('vibebp_touch_all_mails',array($this,'email_templates'),9999);

		$this->run_touchpoints();

	}

	function email_templates($templates){
        $mails = $this->all_mails();
        $templates = array_merge($templates,$mails);
        return $templates;
    }

    function all_mails(){
        $all_mails = array(
            'student_vibe_forms_submitted'=>array(
                'description'=> __('Student vibe form submitted','vibeforms'),
                'subject' =>  __('You submitted the form','vibeforms'),
                'message' =>  sprintf(__('You submitted the form %s','vibeforms'),'{{item.title}}')
            ),
            'instructor_vibe_forms_submitted'=>array(
                'description'=> __('User site credentials','vibeforms'),
                'subject' =>  __('Student submitted the form','vibeforms'),
                'message' =>  sprintf(__('User %s submitted the form %s','vibeforms'),'{{{user.link}}}','{{item.title}}')
            ),
        );
        return apply_filters('vibe_projects_all_mails',$all_mails);
    }

	

	function run_touchpoints(){

		if(!defined('VIBE_BP_SETTINGS'))
			return;
		if(empty($this->vibebp_settings))
			$this->vibebp_settings = get_option(VIBE_BP_SETTINGS);

		if(!empty($this->vibebp_settings['touch']) && isset($this->vibebp_settings) && isset($this->vibebp_settings['touch']) && is_array($this->vibebp_settings['touch'])){

			foreach($this->vibebp_settings['touch'] as $key => $value){
				if(!empty($this->get_touch_points()[$key])){
					$hook = $this->get_touch_points()[$key]['hook'];
					if(!empty($hook)){
						
						if(!empty($value['student']['message'])){
							$student_fx = 'student_message_'.$key;
							//print_r($hook);print_r('----------');print_r($student_fx);print_r('----------');
							if(function_exists($student_fx)){
								add_action($hook,$student_fx,10,$this->get_touch_points()[$key]['params']);
							}else{
								add_action($hook,array($this,$student_fx),10,$this->get_touch_points()[$key]['params']);	
							}
						}

						if(!empty($value['student']['notification'])){
							$student_fx = 'student_notification_'.$key;
							if(function_exists($student_fx)){
								add_action($hook,$student_fx,9,$this->get_touch_points()[$key]['params']);
							}else{
								add_action($hook,array($this,$student_fx),9,$this->get_touch_points()[$key]['params']);	
							}	
						}

						if(!empty($value['student']['email'])){
							$student_fx = 'student_email_'.$key;
							if(function_exists($student_fx)){
								add_action($hook,$student_fx,10,$this->get_touch_points()[$key]['params']);
							}else{
								add_action($hook,array($this,$student_fx),10,$this->get_touch_points()[$key]['params']);	
							}
						}

						if(!empty($value['instructor']['message'])){
							$instructor_fx = 'instructor_message_'.$key;
							if(function_exists($instructor_fx)){
								add_action($hook,$instructor_fx,15,$this->get_touch_points()[$key]['params']);
							}else{
								add_action($hook,array($this,$instructor_fx),15,$this->get_touch_points()[$key]['params']);	
							}
						}

						if(!empty($value['instructor']['notification'])){
							$instructor_fx = 'instructor_notification_'.$key;
							if(function_exists($instructor_fx)){
								add_action($hook,$instructor_fx,15,$this->get_touch_points()[$key]['params']);
							}else{
								add_action($hook,array($this,$instructor_fx),15,$this->get_touch_points()[$key]['params']);	
							}
						}

						if(!empty($value['instructor']['email'])){
							$instructor_fx = 'instructor_email_'.$key;
							if(function_exists($instructor_fx)){
								add_action($hook,$instructor_fx,15,$this->get_touch_points()[$key]['params']);
							}else{
								add_action($hook,array($this,$instructor_fx),15,$this->get_touch_points()[$key]['params']);	
							}
						}

						if(!empty($value['admin']['message'])){
							$admin_fx = 'admin_message_'.$key;

							if(function_exists($admin_fx)){
								add_action($hook,$admin_fx,25,$this->get_touch_points()[$key]['params']);
							}else{
								add_action($hook,array($this,$admin_fx),25,$this->get_touch_points()[$key]['params']);	
							}
						}

						if(!empty($value['admin']['notification'])){
							$admin_fx = 'admin_notification_'.$key;
							if(function_exists($admin_fx)){

								add_action($hook,$admin_fx,25,$this->get_touch_points()[$key]['params']);
							}else{
								add_action($hook,array($this,$admin_fx),25,$this->get_touch_points()[$key]['params']);	
							}
						}

						if(!empty($value['admin']['email'])){
							$admin_fx = 'admin_email_'.$key;
							if(function_exists($admin_fx)){
								add_action($hook,$admin_fx,25,$this->get_touch_points()[$key]['params']);
							}else{
								add_action($hook,array($this,$admin_fx),25,$this->get_touch_points()[$key]['params']);	
							}
						}
					}
				}
				
				
			}
		}
	}

	function get_admins(){
		$admin_ids=array();
		if(empty($this->admin_ids)){
			$this->admin_ids = array();
		 	$user_query = new WP_User_Query( array( 'role' => 'Administrator' ,'fields' => array('ID','user_email')) );
			foreach( $user_query->results as $user){
				$admin_ids[] = array('ID' => $user->ID,'email'=> $user->user_email);
			}
			$this->admin_ids = $admin_ids;
		}

		return $this->admin_ids;
	}

	function add_vibe_forms_touch_points($args){
		foreach ($this->get_touch_points() as $key => $touchpoint) {
			$args[$key] = $touchpoint;
		}
    	return $args;
    }

    function get_touch_points(){
    	$args['vibe_forms_submitted'] = array(
			'label' => __('Form submitted','vibeforms'),
			'name' =>'vibe_forms_submitted',
			'value' => array(
				'student' => admin_url('edit.php?taxonomy=bp-email-type&term=student_vibe_forms_submitted&post_type=bp-email'),
				'instructor' => admin_url('edit.php?taxonomy=bp-email-type&term=instructor_vibe_forms_submitted&post_type=bp-email'),
			),
			'type' => 'touchpoint',
			'hook' => 'vibe_forms_submitted',
			'params'=>4,
		);

    	
    	return apply_filters('vibe_forms_touch_points',$args);

    }
   
    function student_message_vibe_forms_submitted($item_id,$user_id,$data,$comment){
    	if(!function_exists('messages_new_message'))
    		return;
    	$author_id =  $this->get_post_author($item_id);
		$message = sprintf(__('You submitted the form %s','vibeforms'),$this->get_post_title($item_id));
	    if(bp_is_active('messages') )
	      messages_new_message( array('sender_id' => $author_id, 'subject' => __('Form submitted','vibeforms'), 'content' => $message,   'recipients' => array($user_id)) );
    	
    }
    function student_notification_vibe_forms_submitted($item_id,$user_id,$data,$comment){
		vibe_forms_add_notification( array(
			'user_id'          => $user_id,
			'item_id'          => $item_id,
			'secondary_item_id' => $user_id,
			'component_action' => 'student_vibe_forms_submitted'
		));
    		
    }

    function student_email_vibe_forms_submitted($item_id,$user_id,$data,$comment){
    	$to = [];
    	$enable = get_user_meta($user_id,'vibe_forms_submitted',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id', $user_id);
			if(!empty($user) && !is_wp_error($user)){
				$to[] = $user->user_email;
			}
		}

    	
    	bp_send_email('student_vibe_forms_submitted',$to,[
			'tokens'=>[
				'item.title'=>$this->get_post_title($item_id),
		]]);
    }

    function instructor_message_vibe_forms_submitted($item_id,$user_id,$data,$comment){
    	if(!function_exists('messages_new_message'))
    		return;
    	$author_id =  $this->get_post_author($item_id);
		$message = sprintf(__('User %s submitted the form %s','vibeforms'),bp_core_get_userlink($user_id),$this->get_post_title($item_id));
	    if(bp_is_active('messages') )
	      messages_new_message( array('sender_id' => $user_id, 'subject' => __('Form submitted','vibeforms'), 'content' => $message,   'recipients' => array($author_id) ) );
    }

    function instructor_notification_vibe_forms_submitted($item_id,$user_id,$data,$comment){
    	$author_id = $this->get_post_author($item_id);
    	vibe_forms_add_notification( array(
			'user_id'          => $author_id,
			'item_id'          => $item_id,
			'secondary_item_id' => $user_id,
			'component_action' => 'instructor_vibe_forms_submitted'
		));
    }

    function instructor_email_vibe_forms_submitted($item_id,$user_id,$data,$comment){
    	$to = [];
    	$author_id = $this->get_post_author($item_id);
    	$enable = get_user_meta($author_id,'vibe_forms_submitted',true);
		if($enable !== 'no'){
			$user = get_user_by( 'id', $author_id);
			if(!empty($user) && !is_wp_error($user)){
				$to[] = $user->user_email;
			}
		}

    	bp_send_email('instructor_vibe_forms_submitted',$to,[
			'tokens'=>[
				'item.title'=>$this->get_post_title($item_id),
				'user.link'=>bp_core_get_userlink($user_id),
				
		]]);
    }
    function get_post_author($item_id){
    	if(empty($this->post_author[$item_id])){
    		$this->post_author[$item_id] = get_post_field( 'post_author', $item_id );
    	}
    	return $this->post_author[$item_id];
    }
    function get_post_title($item_id){
    	if(empty($this->post_title[$item_id])){
    		$this->post_title[$item_id] = get_the_title(  $item_id );
    	}
    	return $this->post_title[$item_id];
    }

}

function bp_vibe_forms_format_notifications( $action, $item_id, $secondary_item_id, $total_items, $format = 'string' ) {
	$notification ='';	
	switch ($action) {
		case 'student_vibe_forms_submitted':
			$notification = sprintf(__('You submitted the form %s','vibe-froms'),$this->get_post_title($item_id));
		break;
		case 'instructor_vibe_forms_submitted':
			$notification = sprintf(__('User %s submitted the form %s','vibe-froms'),bp_core_get_userlink($secondary_item_id),$this->get_post_title($item_id));
		break;
	}
	return $notification;
}


add_action('bp_init',function(){

	$vibe_tc = VibeForms_Touchpoints::init();
});


