<?php

/*
Plugin Name: VibeForms
Plugin URI: http://www.vibethemes.com/
Description: This plugin extends WPLMS 4 Form creation,sharing and submission
Version: 1.0
Author: Vibethemes
Author URI: http://www.vibethemes.com/
Text Domain: vibeforms
Domain Path: /languages/
*/

if ( !defined( 'ABSPATH' ) ) exit; 

if(!defined('VIBEFORMS_VERSION'))
    define('VIBEFORMS_VERSION',rand(1,999999));
if( !defined('VIBE_FORMS_SLUG')){
    define( 'VIBE_FORMS_SLUG', 'vibeforms' ); 
}

if ( ! defined( 'VIBE_FORMS_PLUGIN_DIR' ) ) {
    define( 'VIBE_FORMS_PLUGIN_DIR', plugin_dir_path( __FILE__ ) );
}

if(!defined('VIBEFORMS_API_NAMESPACE'))
    define('VIBEFORMS_API_NAMESPACE','vibeforms/v1');


if(!defined('VIBEFORMS_SETTINGS_OPTION'))
    define('VIBEFORMS_SETTINGS_OPTION','vibeforms');


if ( ! defined( 'VIBEFORMS_SLUG' ) )
	define( 'VIBEFORMS_SLUG', 'forms' );


if ( ! defined( 'VIBEFORMS_TYPE_SLUG' ) )
	define( 'VIBEFORMS_TYPE_SLUG', 'form-type' );

if( !defined('VIBE_FORMS_UPDATE_URL')){
    define( 'VIBE_FORMS_UPDATE_URL', 'https://vibethemes.com' ); 
}



include_once 'includes/class.updater.php';
include_once 'includes/class.config.php';
include_once 'includes/functions.php';
include_once 'includes/class.component.php';
include_once 'includes/class.api.php';
include_once 'includes/class.filters.php';
include_once 'includes/class.actions.php';
include_once 'includes/class.touchpoints.php';
include_once 'includes/class.formwidget.php';



add_action('plugins_loaded','vibeforms_translations');
function vibeforms_translations(){
    $locale = apply_filters("plugin_locale", get_locale(), 'vibeforms');
    $lang_dir = dirname( __FILE__ ) . '/languages/';
    $mofile        = sprintf( '%1$s-%2$s.mo', 'vibeforms', $locale );
    $mofile_local  = $lang_dir . $mofile;
    $mofile_global = WP_LANG_DIR . '/plugins/' . $mofile;

    if ( file_exists( $mofile_global ) ) {
        load_textdomain( 'vibeforms', $mofile_global );
    } else {
        load_textdomain( 'vibeforms', $mofile_local );
    }  
}

function Vibe_Forms_Plugin_updater() {
    $license_key = trim( get_option( 'vibeforms_license_key' ) );
    $edd_updater = new Vibe_Forms_Plugin_Updater( VIBE_FORMS_UPDATE_URL, __FILE__, array(
            'version'   => VIBEFORMS_VERSION,
            'license'   => $license_key,
            'item_name' => 'Vibe Forms',
            'author'    => 'VibeThemes'
        )
    );
}
add_action( 'admin_init', 'Vibe_Forms_Plugin_updater', 0 );